package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ItemAdicionalDAO;
import com.rjconsultores.ventaboletos.entidad.ItemAdicional;
import com.rjconsultores.ventaboletos.entidad.Pacote;

@Repository("itemAdicionalDAO")
public class ItemAdicionalHibernateDAO extends GenericHibernateDAO<ItemAdicional, Integer> implements ItemAdicionalDAO {

	@Autowired
	public ItemAdicionalHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<ItemAdicional> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("descitemadicional"));

		return c.list();
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<ItemAdicional> buscaItemAdicionalPacote(Pacote pacote) {

		StringBuilder sb = new StringBuilder();
		sb.append(" select pi.itemAdicional ");
		sb.append(" from PacoteItem pi ");
		sb.append(" where pi.pacote.pacoteId = :pacoteId ");
		sb.append("   and pi.activo = 1 ");

		Query query = getSession().createQuery(sb.toString());
		query.setInteger("pacoteId", pacote.getPacoteId());

		return query.list();
	}

}
